<?php
/* CSS framework started as a small addition and grew into a very complex file which is no longer essential for 0.1 release of mp */
/* please do not touch this file until 0.1 has been released and we can implement this with default styles and merges =) */
header('Content-type: text/css');
$css_options = array(
    /* Do not change the reset unless you know what you're doing!  */
    'reset' => array(
        'selection' => array (
            'background_color'  => '#FF5E99',
            'color'             => '#FFFFFF',
            'text_shadow'       => 'none'
        )
    ),
    'admin' => array(
        'primary' => array(
            'header' => array(
                /* All things that affect the background */
                /* Keep colors in 6 character hex-codes to ensure it works accross all platforms */
                'background_color'      => '#545454',
                'background_image'      => 'none',
                'background_position'   => 'none',
                'background_repeat'     => 'no-repeat',
                'gradient_top'          => '#545454',
                'gradient_bottom'       => '#424242',

                /* All things that affect the text */
                'color'                 => '#EEEEEE',
                'font-size'             => '1.4rem',    /* 1.4rem = 14px */
                'font-family'           => 'Sans-serif',
                'text-transform'        => 'none',
                'text-decoration'       => 'none',
                'font-weight'           => 'normal',
                'font-style'            => 'normal',
                'text-align'            => 'left',

                /* To use borders, border_width, border_style and border_color fields must have values */
                /* To inherit borders, type 'inherit' in border_style and false in border_width and border_color */
                /* To remove  borders, type 'none'    in border_style and false in border_width and border_color */
                'border_width'          => '0 0 3px 0',
                'border_style'          => 'double',
                'border_color'          => '#CCCCCC',

                /* To use border_radius, type a value and unit followed by a space then the next value and unit, up to 4 values and units */
                /* First  value indicates the top    left  corner */
                /* Second value indicates the top    right corner */
                /* Third  value indicates the bottom right corner */
                /* Fourth value indicates the bottom left  corner */
                'border_radius'         => '0',

                /* To use shadows, box_shadow_position, box_shadow_blur and box_shadow_color fields must have values */
                /* To use box_shadow_position, type a value and unit followed by a space then the next value and unit */
                /* First  value indicates horizontal shadow */
                /* Second value indicates vertical   shadow */
                'box_shadow_position'   => '0 0',
                'box_shadow_blur'       => '0',
                'box_shadow_color'      => 'transparent'
            ),
            'header_hover' => array(
                'background_color'      => '#545454',
                'background_image'      => 'none',
                'background_position'   => '0 0',
                'background_repeat'     => 'no-repeat',
                'gradient_top'          => '#424242',
                'gradient_bottom'       => '#545454',
                'color'                 => '#EEEEEE',
                'font-size'             => '1.4rem',
                'font-family'           => 'Sans-serif',
                'text-transform'        => 'none',
                'text-decoration'       => 'none',
                'font-weight'           => 'normal',
                'font-style'            => 'normal',
                'text-align'            => 'left',
                'border_width'          => '0 0 3px 0',
                'border_style'          => 'double',
                'border_color'          => '#CCCCCC',
                'border_radius'         => '0',
                'box_shadow_position'   => '0 0',
                'box_shadow_blur'       => '0',
                'box_shadow_color'      => 'transparent'
            ),
            'body' => array(
                'background_color'      => '#F7F7F7',
                'background_image'      => 'none',
                'background_position'   => '0 0',
                'background_repeat'     => 'no-repeat',
                'gradient_top'          => '#F7F7F7',
                'gradient_bottom'       => '#F7F7F7',
                'color'                 => '#444444',
                'font-size'             => '1.4rem',
                'font-family'           => 'Sans-serif',
                'text-transform'        => 'normal',
                'text-decoration'       => 'none',
                'font-weight'           => 'normal',
                'font-style'            => 'normal',
                'text-align'            => 'left',
                'border_width'          => false,
                'border_style'          => 'none',
                'border_color'          => false,
                'border_radius'         => '0',
                'box_shadow_position'   => '0 0',
                'box_shadow_blur'       => '0',
                'box_shadow_color'      => 'transparent'
            ),
            'body_hover' => array(
                'background_color'      => '#F7F7F7',
                'background_image'      => 'none',
                'background_position'   => '0 0',
                'background_repeat'     => 'no-repeat',
                'gradient_top'          => '#F7F7F7',
                'gradient_bottom'       => '#F7F7F7',
                'color'                 => '#444444',
                'font-size'             => '1.4rem',
                'font-family'           => 'Sans-serif',
                'text-transform'        => 'normal',
                'text-decoration'       => 'none',
                'font-weight'           => 'normal',
                'font-style'            => 'normal',
                'text-align'            => 'left',
                'border_width'          => false,
                'border_style'          => 'none',
                'border_color'          => false,
                'border_radius'         => '0',
                'box_shadow_position'   => '0 0',
                'box_shadow_blur'       => '0',
                'box_shadow_color'      => 'transparent'
            ),
            'title'         => false,
            'title_hover'   => false,
            'text' => array(
                'background_color'      => '#FFFFFFF',
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'link' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'link_hover' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'emphasis_neutral' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'emphasis_success' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'emphasis_error' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'form_labels' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'form_select' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'form_inputs' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'primary_button' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'primary_button_hover' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'footer' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'footer_hover' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            )
        ),
        'secondary' => array(
            'header' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'header_hover' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'body' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'body_hover' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'title' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'title_hover' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'text' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'link' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'link_hover' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'emphasis_neutral' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'emphasis_success' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'emphasis_error' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'form_labels' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'form_select' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'form_inputs' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'primary_button' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'primary_button_hover' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'footer' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            ),
            'footer_hover' => array(
                'background_color'      => false,
                'background_image'      => false,
                'background_position'   => false,
                'background_repeat'     => false,
                'gradient_top'          => false,
                'gradient_bottom'       => false,
                'color'                 => false,
                'font-size'             => false,
                'font-family'           => false,
                'text-transform'        => false,
                'text-decoration'       => false,
                'font-weight'           => false,
                'font-style'            => false,
                'text-align'            => false,
                'border_width'          => false,
                'border_style'          => false,
                'border_color'          => false,
                'border_radius'         => false,
                'box_shadow_position'   => false,
                'box_shadow_blur'       => false,
                'box_shadow_color'      => false
            )
        )
    )
);
?>
::selection, ::-moz-selection {
    background: <?php echo $css_options['reset']['selection']['background_color']; ?>;
    color: <?php echo $css_options['reset']['selection']['color']; ?>;
    text-shadow: <?php echo $css_options['reset']['selection']['text_shadow']; ?>;
}
body {
    background-color: <?php echo $css_options['admin']['primary']['background_color']; ?>;
    background-image: -moz-linear-gradient(100% 100% 90deg, <?php echo $css_options['admin']['primary']['gradient_bottom']; ?>, <?php echo $css_options['admin']['primary']['gradient_top']; ?>);
    background-image: -webkit-gradient(linear, 0% 0%, 0% 100%, from(<?php echo $css_options['admin']['primary']['gradient_top']; ?>), to(<?php echo $css_options['admin']['primary']['gradient_bottom']; ?>));
    background-image: -o-linear-gradient(<?php echo $css_options['admin']['primary']['gradient_bottom']; ?>,<?php echo $css_options['admin']['primary']['gradient_top']; ?>);
    filter: progid:DXImageTransform.Microsoft.gradient(GradientType=0, startColorstr=<?php echo $css_options['admin']['primary']['gradient_top']; ?>, endColorstr=<?php echo $css_options['admin']['primary']['gradient_bottom']; ?>); /* IE6 & IE7 */
    -ms-filter:progid:DXImageTransform.Microsoft.gradient(GradientType=0, startColorstr='<?php echo $css_options['admin']['primary']['gradient_top']; ?>', endColorstr='<?php echo $css_options['admin']['primary']['gradient_bottom']; ?>'); /* IE8 & IE9 */
}
.some-type-of-box {
    box-shadow:1px 1px 5px #BBB;
    -moz-box-shadow:1px 1px 5px #BBB;
    -webkit-box-shadow:1px 1px 5px #BBB;
}
.admin_navigation_background_color {
    background-color: <?php echo $css_options['admin']['navigation']['background_color']; ?>;
}
.admin_header {
    background-color: <?php echo $css_options['admin']['header']['background_color']; ?>;
    background-image: -moz-linear-gradient(100% 100% 90deg, <?php echo $css_options['admin']['header']['gradient_bottom']; ?>, <?php echo $css_options['admin']['header']['gradient_top']; ?>);
    color:  <?php echo $css_options['admin']['header']['color']; ?>;
}
